#!/usr/bin/env python
# -*- coding: utf8 -*-
import sys, os, subprocess

from PyQt4 import Qt, QtCore, QtGui, uic

from PyKDE4.solid import Solid

app = QtGui.QApplication (sys.argv)
form_class, base_class = uic.loadUiType ('kflash.ui')

class kflash (QtGui.QWidget, form_class):
    
    lst = None
    str_mkdosfs = "/sbin/mkdosfs"
    str_ext2 = "/sbin/mke2fs"
    str_dd = "/bin/dd"
    def __init__(self, *args):
        super (kflash, self).__init__(*args)        
        self.setupUi (self)
        self.lineEdit.insert("kflash")
        self.format_list()
        self.device_path()
        #ищем необходимые консольные утилиты:
        if (os.path.exists(self.str_mkdosfs)):
            self.label_3.setText(self.label_3.text() + QtCore.QString.fromUtf8("Найдена программа mkdosfs.\n"))
            self.comboBox_2.insertItem (0,"fat32")
        else:
            self.label_3.setText(self.label_3.text() + QtCore.QString.fromUtf8("mkdosfs не найдена.(Возможно вам надо установить необходимый пакет)"))
        if (os.path.exists(self.str_ext2)):
            self.label_3.setText(self.label_3.text() + QtCore.QString.fromUtf8("Найдена программа mke2fs.\n"))
            self.comboBox_2.insertItem (1,"ext2")
        else:
            self.label_3.setText(self.label_3.text() + QtCore.QString.fromUtf8("mke2fs не найдена."))
        if (os.path.exists(self.str_dd)):
            self.label_3.setText(self.label_3.text() + QtCore.QString.fromUtf8("Найдена программа dd.\n"))
        else:
            self.label_3.setText(self.label_3.text() + QtCore.QString.fromUtf8("dd не найдена. Полное форматирование не доступно"))
            self.radioButton_2.setEnabled(0)
            
        #connects
        #self.comboBox.activated.connect(self.device_path)
        self.connect(self.comboBox,QtCore.SIGNAL("activated ()"),self.device_path)
        self.connect(self.pushButton_2,QtCore.SIGNAL("clicked ()"),QtGui.qApp,QtCore.SLOT("quit ()"))
        self.connect(self.pushButton,QtCore.SIGNAL("clicked ()"),self.format_flash)
        
    #Формируется список блочных устройств из них выбираем юсб-устройства
    def format_list(self):        
        # convert enum values to strings for display
        bus2Str = {Solid.StorageDrive.Ide : "IDE",\
                   Solid.StorageDrive.Usb : "USB",\
                   Solid.StorageDrive. Ieee1394 : "IEE1394",\
                   Solid.StorageDrive.Scsi : "SCSI",\
                   Solid.StorageDrive.Sata : "SATA",\
                   Solid.StorageDrive.Platform : "Platform"
                  }        
        deviceList = Solid.Device.listFromType (Solid.DeviceInterface.Block)
        devices = {"stroka": "znachenie"}
        for device in deviceList:                
                drive = device.asDeviceInterface (Solid.DeviceInterface.Block)
                drive_str = str(drive.device ())                    
                if device.isDeviceInterface (Solid.DeviceInterface.StorageDrive) and bus2Str[device.asDeviceInterface(Solid.DeviceInterface.StorageDrive).bus()] == "USB":
                    dev_bus = device.asDeviceInterface (Solid.DeviceInterface.StorageDrive)
                    device_str = str (device.vendor () +" "+ device.product ())                    
                    devices.update({device_str: drive_str})                    
                    self.comboBox.insertItem (0, device_str)
        self.lst = {1:deviceList,2:devices}

    #Для выбранного устройства ищем путь (он же раздел) в /dev/blabla
    def device_path(self):
        j = 0
        while j <= self.comboBox_3.count():
            self.comboBox_3.removeItem(0)
            j = j + 1
        i = 0
        #self.lst.get(1).reverse()
        for device in self.lst.get(1):
            str_1 = str(device.asDeviceInterface (Solid.DeviceInterface.Block).device())
            str_2 = self.lst.get(2).get(str(self.comboBox.currentText()),"None")
            if str_2 in str_1:
                if str_1 != str_2:
                    self.comboBox_3.insertItem(i,str_1)
                    i = i +1

    def format_flash(self):
        rez = QtGui.QMessageBox.warning(self,"kflash",u"Все данные будут уничтожены",QtGui.QMessageBox.Yes|QtGui.QMessageBox.Cancel)
        if  rez == QtGui.QMessageBox.Yes:
            self.setCursor(QtCore.Qt.CursorShape(QtCore.Qt.WaitCursor))
            if self.radioButton.isChecked():
                self.pushButton_2.setEnabled(0)
                self.pushButton.setEnabled(0)
                str_1 = self.sbor()
                for v1 in str_1:
                    self.label_3.setText(self.label_3.text()+v1)
                p = subprocess.Popen(str_1,shell = False, stdout = subprocess.PIPE)
                p.wait()
                lines = p.stdout.readlines()
                for line in lines:
                    self.label_3.setText(line + u"\nВыполнено.")
            elif self.radioButton_2.isChecked():
                self.pushButton_2.setEnabled(0)
                self.pushButton.setEnabled(0)
                str_1 = []
                str_1.append(self.str_dd)
                str_1.append("if=/dev/zero")
                str_1.append("of=" + str(self.comboBox_3.currentText()))
                p = subprocess.Popen(str_1,shell = False,stdout = subprocess.PIPE)
                p.wait()
                lines = p.stdout.readlines()
                #self.label_3.setText(str_1 + "\n")
                for line in lines:
                    self.label_3.setText(self.label_3.text() + line)
                str_1 = self.sbor()
                #self.label_3.setText(self.label_3.text() + str_1)
                p = subprocess.Popen(str_1,shell = False,stdout = subprocess.PIPE)
                p.wait()
                lines = p.stdout.readlines()
                #self.label_3.setText(str_1 + "\n")
                for line in lines:
                    self.label_3.setText(self.label_3.text() + line)
            self.label_3.setText(u"Операция выполнена успешно.")
            self.pushButton_2.setEnabled(1)
            self.pushButton.setEnabled(1)
            self.setCursor(QtCore.Qt.CursorShape(QtCore.Qt.ArrowCursor))
        else:
            self.label_3.setText(u"Операция отменена")
            
    def sbor(self):
        str_1 = []
        if self.comboBox_2.currentText() == "fat32":
            str_1.append(self.str_mkdosfs)
            str_1.append("-F32")
            if self.checkBox.isEnabled():
                str_1.append("-n")
                str_1.append("\"" + self.lineEdit.text() + "\"")
            str_1.append(self.comboBox_3.currentText())
            #self.label_3.setText(str_1)
        elif self.comboBox_2.currentText() == "ext2":
            str_1.append(self.str_ext2)
            str_1.append("-t ext2")
            if self.checkBox.isEnabled():
                str_1.append("-L " + "\"" + self.lineEdit.text() + "\"")
            str_1.append(self.comboBox_3.currentText())
            #self.label_3.setText(str_1)
        return str_1

form = kflash()
form.show()
sys.exit(app.exec_())